//------------------------------------------------------------------------------
// The contents of this file are subject to the nopCommerce Public License Version 1.0 ("License"); you may not use this file except in compliance with the License.
// You may obtain a copy of the License at  http://www.nopCommerce.com/License.aspx. 
// 
// Software distributed under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. 
// See the License for the specific language governing rights and limitations under the License.
// 
// The Original Code is nopCommerce.
// The Initial Developer of the Original Code is NopSolutions.
// All Rights Reserved.
// 
// Contributor(s): _______. 
//------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using NopSolutions.NopCommerce.Common.Categories;
using NopSolutions.NopCommerce.Common.Manufacturers;
using NopSolutions.NopCommerce.Common.Media;
using NopSolutions.NopCommerce.Common.Products;
using NopSolutions.NopCommerce.Common.Products.Specs;
using NopSolutions.NopCommerce.Common.Templates;
using NopSolutions.NopCommerce.Common.Utils;
using NopSolutions.NopCommerce.Web.Administration.Modules;

namespace NopSolutions.NopCommerce.Web.Administration.Modules
{
    public partial class ProductSpecificationsControl : BaseNopAdministrationUserControl
    {
        private void BindData()
        {
            Product product = ProductManager.GetProductByID(this.ProductID);
            if (product != null)
            {
                ProductSpecificationAttributeCollection productSpecificationAttributes = product.ProductSpecificationAttributes;
                if (productSpecificationAttributes.Count > 0)
                {
                    gvProductSpecificationAttributes.Visible = true;
                    gvProductSpecificationAttributes.DataSource = productSpecificationAttributes;
                    gvProductSpecificationAttributes.DataBind();
                }
                else
                    gvProductSpecificationAttributes.Visible = false;
            }
        }

        private void FillDropDowns()
        {
            this.ddlNewProductSpecificationAttribute.Items.Clear();
            SpecificationAttributeCollection productSpecificationAttributes = SpecificationAttributeManager.GetSpecificationAttributes();
            foreach (SpecificationAttribute sa in productSpecificationAttributes)
            {
                ListItem item2 = new ListItem(sa.Name, sa.SpecificationAttributeID.ToString());
                this.ddlNewProductSpecificationAttribute.Items.Add(item2);
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                this.FillDropDowns();
                this.BindData();
            }
        }

        public void SaveInfo()
        {
        }

        protected void btnNewProductSpecification_Click(object sender, EventArgs e)
        {
            try
            {
                Product product = ProductManager.GetProductByID(this.ProductID);
                if (product != null)
                {
                    int specificationAttributeID = int.Parse(ddlNewProductSpecificationAttribute.SelectedItem.Value);

                    ProductSpecificationAttribute productSpecificationAttribute = SpecificationAttributeManager.InsertProductSpecificationAttribute(product.ProductID,
                        specificationAttributeID, txtNewProductSpecificationAttributeValue.Text, txtNewProductSpecificationAttributeDisplayOrder.Value);

                    BindData();
                }
            }
            catch (Exception exc)
            {
                ProcessException(exc);
            }
        }

        protected void gvProductSpecificationAttributes_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            if (e.CommandName == "UpdateProductSpecificationAttribute")
            {
                int index = Convert.ToInt32(e.CommandArgument);
                GridViewRow row = gvProductSpecificationAttributes.Rows[index];

                HiddenField hfProductSpecificationAttributeID = row.FindControl("hfProductSpecificationAttributeID") as HiddenField;
                DropDownList ddlSpecificationAttribute = row.FindControl("ddlSpecificationAttribute") as DropDownList;
                SimpleTextBox txtProductSpecificationAttributeValue = row.FindControl("txtProductSpecificationAttributeValue") as SimpleTextBox;
                NumericTextBox txtProductSpecificationAttributeDisplayOrder = row.FindControl("txtProductSpecificationAttributeDisplayOrder") as NumericTextBox;

                int productSpecificationAttributeID = int.Parse(hfProductSpecificationAttributeID.Value);
                int specificationAttributeID = int.Parse(ddlSpecificationAttribute.SelectedItem.Value);
                int displayOrder = txtProductSpecificationAttributeDisplayOrder.Value;

                ProductSpecificationAttribute productSpecificationAttribute = SpecificationAttributeManager.GetProductSpecificationAttributeByID(productSpecificationAttributeID);

                if (productSpecificationAttribute != null)
                    SpecificationAttributeManager.UpdateProductSpecificationAttribute(productSpecificationAttribute.ProductSpecificationAttributeID,
                       productSpecificationAttribute.ProductID, specificationAttributeID,
                       txtProductSpecificationAttributeValue.Text, displayOrder);

                BindData();
            }
        }

        protected void gvProductSpecificationAttributes_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                ProductSpecificationAttribute productSpecificationAttribute = (ProductSpecificationAttribute)e.Row.DataItem;

                Button btnUpdate = e.Row.FindControl("btnUpdate") as Button;
                if (btnUpdate != null)
                    btnUpdate.CommandArgument = e.Row.RowIndex.ToString();

                DropDownList ddlSpecificationAttribute = e.Row.FindControl("ddlSpecificationAttribute") as DropDownList;
                ddlSpecificationAttribute.Items.Clear();
                SpecificationAttributeCollection specificationAttributes = SpecificationAttributeManager.GetSpecificationAttributes();
                foreach (SpecificationAttribute specificationAttribute in specificationAttributes)
                {
                    ListItem item = new ListItem(specificationAttribute.Name, specificationAttribute.SpecificationAttributeID.ToString());
                    ddlSpecificationAttribute.Items.Add(item);
                    if (productSpecificationAttribute.SpecificationAttributeID == specificationAttribute.SpecificationAttributeID)
                        item.Selected = true;
                }
            }
        }

        protected void gvProductSpecificationAttributes_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            int productSpecificationAttributeID = (int)gvProductSpecificationAttributes.DataKeys[e.RowIndex]["ProductSpecificationAttributeID"];
            ProductSpecificationAttribute productSpecificationAttribute = SpecificationAttributeManager.GetProductSpecificationAttributeByID(productSpecificationAttributeID);
            if (productSpecificationAttribute != null)
            {
                SpecificationAttributeManager.DeleteProductSpecificationAttribute(productSpecificationAttribute.ProductSpecificationAttributeID);
                BindData();
            }
        }

        public int ProductID
        {
            get
            {
                return CommonHelper.QueryStringInt("ProductID");
            }
        }
    }
}